// This file is a part of Framsticks SDK.  http://www.framsticks.com/
// Copyright (C) 1999-2020  Maciej Komosinski and Szymon Ulatowski.
// See LICENSE.txt for details.

#ifndef _SIMIL_MEASURE_H
#define _SIMIL_MEASURE_H

#include "frams/model/similarity/measure-greedy.h"
#include "frams/model/similarity/measure-hungarian.h"
#include "frams/model/similarity/measure-distribution.h"

class SimilMeasure
{
public:
	int measure_type;

	SimilMeasureGreedy simil_measure_greedy;
	SimilMeasureHungarian simil_measure_hungarian;
	SimilMeasureDistribution simil_measure_distribution;

	/// Interface to local parameters
	Param localpar;

	SimilMeasure();
	virtual ~SimilMeasure() {};
	double evaluateDistance(const Geno *G0, const Geno *G1);

	#define STATRICKCLASS SimilMeasure
	PARAMPROCDEF(p_evaldistance);
	#undef STATRICKCLASS
};

#endif
